<%@ page language="java" import="java.util.*" %>
<%@ page language="java" import="java.io.*" %>

<HTML>
<BODY bgcolor="#ffffff">
<%

	String answer = request.getParameter("answer");

	if (answer == null)
	{
%>
<H1>Oops!</H1>
You tried to vote without voting on anything!
</BODY>
</HTML>
<%
		return;
	}
	
	try
	{
// See if there is a property pointing to the poll directory
		String pollDirectory = System.getProperty("poll.dir");

		File pollFile = null;
		File tempFile = null;

// If the directory has been specified, look for the poll
// file there (the poll file describes the question and possible
// answers for the poll)

		if (pollDirectory != null)
		{
			pollFile = new File(pollDirectory, "poll.dat");
			tempFile = new File(pollDirectory, "poll.tmp");
		}
		else
		{
			pollFile = new File("poll.dat");
			tempFile = new File("poll.tmp");
		}

// To add an entry to the poll, this program just creates a new
// version of the poll data file, updating the count for the answer
// provided

		boolean createSucceeded = false;

// Loop until the file is available or there have been too many tries
		for (int i=0; i < 30; i++)
		{

// Only one process or thread can create the temp file, others fail
// if the file exists. In other words, only one thread can be updating
// the poll data.
			if (tempFile.createNewFile())
			{
				createSucceeded = true;
				break;
			}

// Up to this point, the create has failed. Sleep for 1 second
// and try again
			try {
				Thread.sleep(1000);
			} catch (Exception ignore) {}
		}

		if (!createSucceeded)
		{
			throw new IOException("Unable to lock file");
		}

// Create a temporary holder for the counts and answers
		Vector counts = new Vector();
		Vector answers = new Vector();
		int totalVotes = 0;

		try
		{

// Try to read the poll.dat file
			BufferedReader in = new BufferedReader(
				new FileReader(pollFile));

// Output will go to the temp file
			PrintWriter pollOut = new PrintWriter(
				new FileWriter(tempFile));

			String line;

			boolean foundAnswer = false;

			while ((line = in.readLine()) != null)
			{
// The poll.dat file should have lines in the form count:answer
// Split out the count and the answer here
				int colonPos = line.indexOf(':');
// If there is no colon, just skip the line
				if (colonPos < 0) continue;

				String countStr = line.substring(0,
					colonPos);
				String answerStr = line.substring(
					colonPos+1);

				int count = 0;
				try
				{
					count = Integer.parseInt(
						countStr);
				} catch (Exception ignore) {}

// Compare the answer sent from the user with the answer on this
// line. If they are the same, increment the count
				if (answerStr.equals(answer))
				{
					foundAnswer = true;
					count++;
				}

				totalVotes = totalVotes + count;

				pollOut.println(count+":"+answerStr);

// Save the answer and the current count
				answers.addElement(answerStr);
				counts.addElement(new Integer(count));
			}

			pollOut.close();
			in.close();

// Now replace the original poll file with the new one
			pollFile.delete();
			tempFile.renameTo(pollFile);

// If the answer from the user was nowhere in the file, tell the
// user there has been an error. This implies that a poll.dat needs
// to be set up ahead of time with all the possible answers and initial
// counts of 0.
// This program could dynamically add answers if they are not found, but
// that would allow someone to put phony answers in by manually calling
// this page with something like:
// http://blahblah/PollVote.jsp?answer=MyPhonyAnswer

			if (!foundAnswer)
			{
%>
<H1>Unexpected Answer</H1>
You entered an answer that the vote taker doesn't recognize.
</BODY>
</HTML>
<%
				return;
			}

		}
		catch (IOException ioExc)
		{
// If there's an error, just delete the temp file, meaning that this
// vote won't be counted and another process can try recording a vote
			try {
				tempFile.delete();
			} catch (Exception ignore) {}
%>
<H1>Sorry!</H1>
The vote taker is unable to record your vote. Please try again later.
</BODY>
</HTML>
<%
			return;
		}
%>
<%-- Now display the poll results --%>
<H2>Thank you for your vote!</H1>
<P>
<B>Here are the current poll results:</B>
<P>
<TABLE>
<%
		int numAnswers = answers.size();

// The counts and answers were saved in a temporary vector

		for (int i=0; i < numAnswers; i++)
		{
			String currAnswer = (String) answers.elementAt(i);
			Integer count = (Integer) counts.elementAt(i);

			int countPct = 0;
			if (totalVotes > 0)
			{
				countPct = (100 * count.intValue()) /
					totalVotes;
			}

%>
<%-- Show each answer as a table row. Stretch out a GIF image horizontally
     to make a bar graph of the various answers, then print the answer,
     the total count and what pct of the total votes the count represents.
--%>
<TR>
<TD><IMG SRC="pollbar.gif" HEIGHT=20 WIDTH="<%=countPct*3%>">
<TD><%=currAnswer%>
<TD><%=count%> (<%=countPct%>%)
<%
		}
%>
</TABLE>
There have been <%=totalVotes%> votes so far.

<%-- Now in case there was an error trying to create the temp file,
     handle any exception that came up --%>
<%
	}
	catch (Exception exc)
	{
		application.log("Error recording vote", exc);
%>
<H1>Sorry!</H1>
The vote taker is unable to record your vote. Please try again later.
<%
	}
%>
</BODY>
</HTML>
