<%@ page language="java" import="java.io.*" %>
<HTML>
<BODY bgcolor="#ffffff">

<%
// First, get all the entries from the survey

// langpref is a select box, there should be a single value
	String langpref = request.getParameter("langpref");

// osdevpref is a radio button, there should be a single value
	String osdevpref = request.getParameter("osdevpref");

// osuse is a checkbox, there are multiple values
	String[] osuse = request.getParameterValues("osuse");
	if (osuse == null) osuse = new String[0];

// technologies is a multi-values select, there are multiple values
	String[] technologies = request.getParameterValues(
		"technologies");
	if (technologies == null) technologies = new String[0];

	String name = request.getParameter("name");
	String email = request.getParameter("email");

// Now write out the survey results to a file
	try
	{

// See if there is a property pointing to the output directory
		String outputDirectory =
			System.getProperty("survey.dir");

		File outputFile = null;
		File renamedFile = null;

// If there is an output directory, create a File that points there
		if (outputDirectory != null)
		{
			outputFile = new File(outputDirectory,
				"survey.out");
			renamedFile = new File(outputDirectory,
				"survey.lck");
		}
		else
		{
// Otherwise, let the file be a relative path based on the current dir
			outputFile = new File("survey.out");
			renamedFile = new File("survey.lck");
		}
		
		boolean renameSucceeded = false;

// Loop until the file is available or there have been too many tries
		for (int i=0; i < 30; i++)
		{

// First, make sure that the original output file exists
			if (outputFile.exists())
			{

// If the rename succeeds, exit the loop and write to the file
				if (outputFile.renameTo(renamedFile))
				{
					renameSucceeded = true;
					break;
				}
			}
			else
			{
// If the output file didn't exist, try creating the renamed file
// directly. The file can only be created if it doesn't exist, so if
// the create fails, someone else is writing the file

				if (renamedFile.createNewFile())
				{
					renameSucceeded = true;
					break;
				}
			}

// Up to this point, the rename has failed. Sleep for 1 second
// and try again
			try {
				Thread.sleep(1000);
			} catch (Exception ignore) {}
		}

		if (!renameSucceeded)
		{
			throw new IOException("Unable to lock file");
		}

// Open the output file
		PrintWriter fileOut = new PrintWriter(
			new FileWriter(renamedFile.getAbsolutePath(),
			true));

		fileOut.println(langpref);
		fileOut.println(osdevpref);

// Loop through the osuse array and
// print the values separated by commas
		for (int i=0; i < osuse.length; i++)
		{
			if (i > 0) fileOut.print(", ");
			fileOut.print(osuse[i]);
		}
		fileOut.println();

// Loop through the technologies array and
// print the values separated by commas
		for (int i=0; i < technologies.length; i++)
		{
			if (i > 0) fileOut.print(", ");
			fileOut.print(technologies[i]);
		}
		fileOut.println();
		fileOut.println(name);
		fileOut.println(email);
		fileOut.println("-----");

		fileOut.close();

// After the file is closed, rename it back to the original
		renamedFile.renameTo(outputFile);
%>

<H1>Thanks!</H1>
Thank you for participating in our survey.  Your feedback is important!

<%
	}
	catch (IOException ioExc)
	{
		application.log("Error saving survey results", ioExc);
%>
<H1>Sorry!</H1>
Due to a server error, we were unable to save your survey results.
We are sorry for the inconvenience and appreciate the time you took to
enter the data. Please try again later.
<%
	}
%>

</BODY>
</HTML>
