package usingjsp;

import javax.servlet.http.*;

/** Counts the number of sessions that are bound to this object. */

public class BindListener implements HttpSessionBindingListener
{
// The current session count
    protected int numSessions;

    public BindListener()
    {
        numSessions = 0;
    }

// Every time this object is added to a session,
// valueBound is called
    public synchronized void valueBound(HttpSessionBindingEvent event)
    {
        numSessions++;
    }

// Every time this object is removed from a session,
// valueUnbound is called
    public synchronized void valueUnbound(HttpSessionBindingEvent event)
    {
        numSessions--;
    }

// Returns the current number of bound sessions
    public int getNumSessions()
    {
        return numSessions;
    }
}
