package usingjsp;

import java.io.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;

public class DispatcherServlet extends GenericServlet
{
    public void service(ServletRequest request,
        ServletResponse response)
        throws java.io.IOException, ServletException
    {

// Get the list of controllers to call
        String[] controllers =
            request.getParameterValues("controller");

// Get the name of the view to call
        String viewName = request.getParameter("view");

// Get the name of the view to call if there is an error
        String errorViewName = request.getParameter("errorView");

        try
        {
            for (int i=0; i < controllers.length; i++)
            {
                RequestDispatcher d =
                    getServletContext().
                        getRequestDispatcher(
                            controllers[i]);
                if (d != null)
                {
// Invoke the next controller
                    d.include(request, response);
                }
                else
                {
                    getServletContext().log(
                        "No controller named "+
                        controllers[i]);
                }
            }

            RequestDispatcher d = getServletContext().
                getRequestDispatcher(viewName);
            
// The dispatcher includes the other controllers, but it forwards to the view
            if (d != null)
            {
                d.forward(request, response);
            }
            else
            {
                getServletContext().log(
                    "No view named "+viewName);
            }
        }
        catch (Exception exc)
        {
// If there is an error, forward to the error view

            request.setAttribute("exception", exc.toString());

            RequestDispatcher d = getServletContext().
                getRequestDispatcher(errorViewName);
            
            if (d != null)
            {
                d.forward(request, response);
            }
            else
            {
                getServletContext().log(
                    "No errorView named "+errorViewName);
            }
        }
    }
}
