package usingjsp;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;

/** An example superclass for a Java Server Page */

public abstract class JSPSuperclass extends HttpServlet
    implements HttpJspPage
{
// init must be declared as final for this to be a superclass for a JSP
    public final void init(ServletConfig config)
        throws ServletException
    {
// Let the superclass do its initialization
        super.init(config);

// Initialize the JSP
        jspInit();
    }

// destroy must be declared as final for this to be a superclass for a JSP
    public final void destroy()
    {
        super.destroy();

        jspDestroy();
    }

// getServletConfig must be declared as final for this to
// be a superclass for a JSP
    public final ServletConfig getServletConfig()
    {
        return super.getServletConfig();
    }

// service must be declared as final for this to be a superclass for a JSP
    public final void service(ServletRequest request,
        ServletResponse response)
        throws ServletException, java.io.IOException
    {
        super.service(request, response);
    }


    public final void service(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, java.io.IOException
    {
// DEMO ALERT! Put a dummy data item in here to show
// the the subclassing works
        request.setAttribute("Demo", "Hello from your superclass");

// Now call the _jspService method to run the JSP
        _jspService(request, response);
    }

// Provide a dummy jspInit method
    public void jspInit()
    {
    }

// Provide a dummy jspDestroy method
    public void jspDestroy()
    {
    }
// The _jspService method is implemented by the servlet generated
// from the JSP page source
    public abstract void _jspService(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, java.io.IOException;
}
