package usingjsp;

import java.util.*;

/** Represents a gymnastics meet for the purpose of scheduling judges */

public class Meet implements java.io.Serializable
{
    public String meetName;
    public String gym;
    public String dates;
    public String levels;

    public Vector vaultJudges;
    public Vector barsJudges;
    public Vector beamJudges;
    public Vector floorJudges;

    public Vector carPools;

/** Creates an empty Meet object */
    public Meet()
    {
    }

/** Creates a new Meet object with data elements populated from a string */
    public Meet(String dataString)
    {
// Assume the data elements are separated by |'s
        StringTokenizer tokens = new StringTokenizer(dataString, "|");

// In a production system, you should really check to make sure there are
// mroe tokens, or at least catch a NoSuchElementException
        meetName = tokens.nextToken();
        gym = tokens.nextToken();
        dates = tokens.nextToken();
        levels = tokens.nextToken();

// Use another routine to parse an element that is a list of items
        vaultJudges = parseStringList(tokens.nextToken());
        barsJudges = parseStringList(tokens.nextToken());
        beamJudges = parseStringList(tokens.nextToken());
        floorJudges = parseStringList(tokens.nextToken());

// The carpool is a list of list, assume each list is separated by ;'s
        if (tokens.hasMoreTokens())
        {
            StringTokenizer carPoolStrings = new StringTokenizer(
                tokens.nextToken(), ";");

            carPools = new Vector();
            while (carPoolStrings.hasMoreTokens())
            {
                carPools.addElement(parseStringList(carPoolStrings.nextToken()));
            }
        }
    }

/** Creates a string representing the data for this class */
    public String toDataString()
    {
        StringBuffer dataBuffer = new StringBuffer();

// Store the fields in the string separated by |'s
        dataBuffer.append(meetName);
        dataBuffer.append("|");
        dataBuffer.append(gym);
        dataBuffer.append("|");
        dataBuffer.append(dates);
        dataBuffer.append("|");
        dataBuffer.append(levels);
        dataBuffer.append("|");

// Store the lists of data
        dataBuffer.append(createStringList(vaultJudges));
        dataBuffer.append("|");
        dataBuffer.append(createStringList(barsJudges));
        dataBuffer.append("|");
        dataBuffer.append(createStringList(beamJudges));
        dataBuffer.append("|");
        dataBuffer.append(createStringList(floorJudges));
        dataBuffer.append("|");

// Store the car pool as a list of lists, with each list separates by ;'s
        Enumeration e = carPools.elements();

        boolean first = true;

        while (e.hasMoreElements())
        {
            if (!first)
            {
                dataBuffer.append(";");
            }
            else
            {
                first = false;
            }
            dataBuffer.append(createStringList((Vector) e.nextElement()));
        }
        
        return dataBuffer.toString();
    }

/** Creates a string containing a list of elements separated by :'s */
    public String createStringList(Vector v)
    {
        StringBuffer dataBuffer = new StringBuffer();

        Enumeration e = v.elements();

        boolean first = true;

        while (e.hasMoreElements())
        {
            if (!first)
            {
                dataBuffer.append(":");
            }
            else
            {
                first = false;
            }
            dataBuffer.append(e.nextElement());
        }

        return dataBuffer.toString();
    }

/** Parses a string of colon-separated items into a vector */
    public Vector parseStringList(String list)
    {
        Vector v = new Vector();

        StringTokenizer tokens = new StringTokenizer(list, ":");

        while (tokens.hasMoreElements())
        {
            v.addElement(tokens.nextToken());
        }

        return v;
    }
}
