<%@ page language="java" import="usingjsp.problemreport.*,java.util.*" %>
<%@ page import="usingjsp.*,java.sql.*,java.text.*" %>

<html>
<body bgcolor="#ffffff">

<%@ include file="CheckLoggedIn.jsp" %>

<form action="SaveProblem.jsp" method="post">

<%

    Vector developers = null;
    Connection conn = null;

    String problemId = request.getParameter("problemId");

    ProblemReport report = new ProblemReport();
    Vector reports = null;

    IConnectionPool pool = (IConnectionPool)
        application.getAttribute("connectionPool");

    String[] assignedDevelopers = null;

    try
    {

        conn = pool.getConnection();

        Developer devQuery = new Developer();

        developers = devQuery.getAll(conn);

// If there is already a problem id, this is an edit instead of a new
// problem report. Go get the original problem report

        if (problemId != null)
        {
            ProblemReport query = new ProblemReport();

            reports = query.getAll(conn, "problem_id="+problemId);

            if (reports.size() < 1)
            {
%>
The problem you want to edit is no longer in the system. Please
try another report.
<p>
<a href="ProblemReporting.jsp">Return to Main Page</a>
<%
                return;
            }

            report = (ProblemReport) reports.elementAt(0);
%>
<input type="hidden" name="problemId" value="<%=report.problemId%>">
<h1>Edit a Problem Report</h1>
<%

// Get the developers assigned to this problem report

            Vector v = devQuery.executeQuery(conn,
                "select "+devQuery.getFieldList("d")+
                " from developer d, problem_report_developer prd where "+
                "prd.problem_id="+report.problemId+
                " and d.developer = prd.developer");

            assignedDevelopers = new String[v.size()];
            for (int i=0; i < assignedDevelopers.length; i++)
            {
                assignedDevelopers[i] = ((Developer) v.elementAt(i)).
                    developer;
            }
        }
        else
        {
// Create a new, blank problem report
            report.entered = new java.util.Date();
            report.system = "";
            report.subsystem = "";
            report.originator = developer;
            report.description = "";
            report.priority = 0;
            report.status = "";
            report.estimatedCompletionDate = new java.util.Date();
            report.notes = new Vector();

            assignedDevelopers = new String[0];
%>
<h1>Enter a New Problem Report</h1>
<%
        }

    }
    finally
    {
        if (conn != null)
        {
            pool.releaseConnection(conn);
        }
    }

    if (developers == null)
    {
        developers = new Vector();
    }

%>

<%
// Preserve the names of the developers previously assigned to this
// problem. That way, the SaveProblem JSP doesn't need to figure it
// out.
    for (int i=0; i < assignedDevelopers.length; i++)
    {
%><input type="hidden" name="prevAssigned"
    value="<%=assignedDevelopers[i]%>"><%
    }
%>
<table>
<tr>
<td>System:
<td><input type="text" name="system" value="<%=report.system%>">
<td>Subsystem:
<td><input type="text" name="subsystem" value="<%=report.subsystem%>">
<tr><td>Description:
</table>
<textarea name=description rows="4" cols="60"><%=report.description%>
</textarea>
<table>
<tr>
<td>Priority:
<td>
<select name="priority">
<%
    for (int i=1; i <= 10; i++)
    {
        out.print("<option value=\""+i+"\"");
        if (i == report.priority) out.print(" selected");
        out.println(">"+i+"</option>");
    }
%>
<td>Status:
<td><input type="text" name="status" value="<%=report.status%>">
</table>
<table>
<tr>
<td>Estimated Completion Date:
<td><input type="text" name="ecd"
    value="<%= (new SimpleDateFormat("MM/dd/yyyy")).format(
        report.estimatedCompletionDate) %>">
</table>
Assigned Developers:
<table>
<tr>
<%
// Create a select list of the developers that can be assigned to a problem
    for (int i=0; i < 4; i++)
    {
%><td><select name="assigned">
<option value="">None</option>
<%
        for (int j=0; j < developers.size(); j++)
        {
            Developer d = (Developer) developers.elementAt(j);

%><option value="<%=d.developer%>"
<%
            if ((i < assignedDevelopers.length) &&
                (d.developer.equals(assignedDevelopers[i])))
            {
                out.print(" selected");
            }
%>
><%=d.developer%></option><%
        }
    }
%>
<tr>
<td>Notes:
</table>
<%
    SimpleDateFormat dateFormat =
        new SimpleDateFormat("mm/dd/yyyy hh:mm:ss");

    Enumeration e = report.notes.elements();
    while (e.hasMoreElements())
    {
        Note note = (Note) e.nextElement();
%>
<%= dateFormat.format(note.date) %> -- <%= note.developer %>
<br>
<%= note.comment %>
<br>
------------------------------------------------------------
<br>
<%
    }
%>
<table>
<tr><td>Enter a New Note:
</table>
<textarea name="newnote" rows="4" cols="60"></textarea>

<p>
<input type="hidden" name="originator" value="<%=report.originator%>">
<input type="submit" value="Save Problem Report">
</form>
</body>
</html>
