package usingjsp.problemreport;

import usingjsp.DatabaseObject;
import java.sql.*;

/** A data object linking a developer to a problem report */

public class ProblemReportDeveloper extends DatabaseObject
    implements java.io.Serializable
{
    public int problemId;
    public String developer;

    public ProblemReportDeveloper()
    {
    }

    public ProblemReportDeveloper(ResultSet results)
        throws SQLException
    {
        problemId = results.getInt("problem_id");
        developer = results.getString("developer");
    }

    public int getProblemId() { return problemId; }
    public void setProblemId(int aProblemId) { problemId = aProblemId; }

    public String getDeveloper() { return developer; }
    public void setDeveloper(String aDeveloper)
        { developer = aDeveloper; }
    
    public String getTableName() { return "problem_report_developer"; }

    public DatabaseObject createInstance(ResultSet results)
        throws SQLException
    {
        return new ProblemReportDeveloper(results);
    }

    public String getFieldList() { return "problem_id, developer"; }

    public String getInsertStatement()
    {
        return "insert into problem_report_developer "+
            "(problem_id, developer) values (?,?)";
    }

    public void prepareInsertStatement(PreparedStatement s)
        throws SQLException
    {
        s.setInt(1, problemId);
        s.setString(2, developer);
    }

    public String getUpdateStatement()
    {
        return null;
    }

    public void prepareUpdateStatement(PreparedStatement s) {}

    public String getDeleteStatement()
    {
        return "delete from problem_report_developer where "+
            "problem_id=? and developer=?";
    }

    public void prepareDeleteStatement(PreparedStatement s)
        throws SQLException
    {
        s.setInt(1, problemId);
        s.setString(2, developer);
    }
}
