<%@ page language="java" import="usingjsp.problemreport.*,java.util.*" %>
<%@ page import="usingjsp.*,java.sql.*,java.text.*" %>

<html>
<body bgcolor="#ffffff">

<%@ include file="CheckLoggedIn.jsp" %>

<jsp:useBean id="report" class="usingjsp.problemreport.ProblemReport"
    scope="page"/>
<%
    Connection conn = null;

    IConnectionPool pool =
        (IConnectionPool) application.getAttribute("connectionPool");

    String problemId = request.getParameter("problemId");

    try
    {
        conn = pool.getConnection();

// If this is not a new problem, go find the previous one
        if (problemId != null)
        {
            ProblemReport prQuery = new ProblemReport();

            Vector v = prQuery.getAll(conn, "problem_id="+problemId);

            if (v.size() > 0)
            {
                report = (ProblemReport) v.elementAt(0);

// Store the object in the page context so you can treat it like a bean
                pageContext.setAttribute("report", report);
            }
        }
%>
<%-- Copy the attributes of the form into the report --%>
<jsp:setProperty name="report" property="*"/>
<%
// Get the note that was entered
        String newNote = request.getParameter("newnote");

// If there was a note, add it to the list of notes for this problem
        if ((newNote != null) && (newNote.trim().length() > 0))
        {
            Note note = new Note(developer, new java.util.Date(),
                newNote);

            if (report.notes == null)
            {
                report.notes = new Vector();
            }
            report.notes.addElement(note);
        }

        String ecdStr = request.getParameter("ecd");

        if (ecdStr != null)
        {
            SimpleDateFormat fmt = new SimpleDateFormat("MM/dd/yyyy");

            report.estimatedCompletionDate = fmt.parse(ecdStr);
        }

// If this is a new problem, set the date/time that it was entered
        if (problemId == null)
        {           
            report.entered = new java.util.Date();
        }

// Do an insert or an update depending on whether this is a new
// problem or an existing one
        if (problemId != null)
        {
            report.update(conn);
        }
        else
        {
            report.insert(conn);
        }

// Get the list of developers that were previously assigned to this problem
        String[] prevAssigned = request.getParameterValues(
            "prevAssigned");
        if (prevAssigned == null) prevAssigned = new String[0];

// Get the list of developers who are now assigned to this problem
        String[] assigned = request.getParameterValues("assigned");

        Vector deleted = new Vector();

// Loop through the developers who were previously assigned to this problem
        for (int i=0; i < prevAssigned.length; i++)
        {
            if ((prevAssigned[i] == null) ||
                (prevAssigned[i].trim().length() == 0))
            {
                continue;
            }
            boolean found = false;

// See if this developer is still assigned to the problem
            for (int j=0; j < assigned.length; j++)
            {
                if (assigned[j].equals(prevAssigned[i]))
                {
                    found = true;
                    break;
                }
            }
// If the developer is no longer assigned, add them to the list
// of developers that need to be deleted
            if (!found) deleted.addElement(prevAssigned[i]);
        }

        Vector added = new Vector();

// Loop through the developers that are now assigned to the problem
        for (int i=0; i < assigned.length; i++)
        {
            if ((assigned[i] == null) || (assigned[i].trim().length() == 0))
            {
                continue;
            }
            boolean found = false;
// Look through the previously assigned developers to see if this developer
// was previously assigned to the problem
            for (int j=0; j < prevAssigned.length; j++)
            {
                if (assigned[i].equals(prevAssigned[j]))
                {
                    found = true;
                    break;
                }
            }

// If the developer was not previously assigned, add them
// to the list of developers that need to be inserted
            if (!found) added.addElement(assigned[i]);
        }

// Create a ProblemReportDeveloper link object to link new developers
// to the problem or remove existing links. The same object can be
// reused to insert and delete multiple links.

        ProblemReportDeveloper prd = new ProblemReportDeveloper();

// The problemId is the same for all developers to be added and deleted
// for this problem
        prd.problemId = report.problemId;

// Delete the developers who are no longer assigned
        for (int i=0; i < deleted.size(); i++)
        {
            prd.developer = (String) deleted.elementAt(i);

            prd.delete(conn);
        }

// Insert the developers who were not previously assigned
        for (int i=0; i < added.size(); i++)
        {
            prd.developer = (String) added.elementAt(i);

            prd.insert(conn);
        }
    }
    finally
    {
        try {
            pool.releaseConnection(conn);
        } catch (Exception ignore) {}
    }
%>
<h1>Success</h1>
<p>
Your problem report has been
<%
    if (problemId != null)
    {
        out.print("updated in the database.");
    }
    else
    {
        out.print("inserted into the database.");
    }
%>
<p>
You may now <a href="ProblemReporting.jsp">return to the Main Page</a>
</body>
</html>
