package usingjsp.cart;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import usingjsp.cart.corba.*;

public class ShoppingCartServlet extends HttpServlet
{
    IShoppingCartFactory factory = null;

    public void service(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException
    {
        try
        {
// Create a new shopping cart for this session
            IShoppingCart cart = factory.createShoppingCart();

            request.getSession().setAttribute("ShoppingCart", cart);

// Forward to the product catalog
            RequestDispatcher dispatcher =
                getServletContext().getRequestDispatcher(
                "/jspbook/Chap22/ShowProductCatalog.jsp");
            
            dispatcher.forward(request, response);
        }
        catch (Exception exc)
        {
            throw new ServletException("Got exception: "+exc.toString());
        }
    }

    public void init()
    {
        try
        {
// Create an instance of the CORBA orb
            ORB orb = ORB.init(
                new String[] { "-ORBInitialPort", "1050" }
                , null);

// Locate the CORBA naming service
            org.omg.CORBA.Object objRef =
                orb.resolve_initial_references("NameService");

// Instead of using the Java cast operator, the correct way to convert
// a CORBA Object into a specific type is to use that type's helper
            NamingContext ncRef = NamingContextHelper.narrow(objRef);

// Create a name component path for locating the MOTD service
            NameComponent nc = new NameComponent(
                "ShoppingCartFactory", "");
            NameComponent path[] = new NameComponent[] { nc };

// Locate the shopping cart factory service and narrow (i.e. cast)
// the reference to an object of type IShoppingCartFactory
            factory = IShoppingCartFactoryHelper.narrow(
                ncRef.resolve(path));
        }
        catch (Exception exc)
        {
            getServletContext().log(
                "Error binding to ShoppingCartFactory service", exc);
        }
    }
}
