package usingjsp.ejb;

public class AddressKey implements java.io.Serializable
{
    public String firstName;
    public String middleName;
    public String lastName;

    public AddressKey() { }

    public AddressKey(String aFirstName, String aMiddleName, String aLastName)
    {
        firstName = aFirstName;
        middleName = aMiddleName;
        lastName = aLastName;
    }

    public String getFirstName() { return firstName; }
    public String getMiddleName() { return middleName; }
    public String getLastName() { return lastName; }

    public boolean equals(Object ob)
    {
        if (ob == this) return true;

        if (!(ob instanceof AddressKey))
        {
            return false;
        }

        AddressKey otherKey = (AddressKey) ob;

        if ((firstName == null) && (otherKey.firstName != null))
        {
            return false;
        }

        if ((middleName == null) && (otherKey.middleName != null))
        {
            return false;
        }

        if ((lastName == null) && (otherKey.lastName != null))
        {
            return false;
        }

        if ((firstName != null) &&
            (!otherKey.firstName.equals(firstName)))
        {
            return false;
        }

        if ((middleName != null) &&
            (!otherKey.middleName.equals(middleName)))
        {
            return false;
        }

        if ((lastName != null) && (!otherKey.lastName.equals(lastName)))
        {
            return false;
        }

        return true;
    }

    public int hashCode()
    {
        int hash = 0;

        if (firstName != null)
        {
            hash = hash + firstName.hashCode();
        }

        if (middleName != null)
        {
            hash = hash + middleName.hashCode();
        }

        if (lastName != null)
        {
            hash = hash + lastName.hashCode();
        }

        return hash;
    }
}
