package usingjsp.xml;

import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

import javax.xml.parsers.*;
import org.xml.sax.*;
import org.w3c.dom.*;

public class DomParseServlet extends HttpServlet
{
    public void doPost(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, IOException
    {
        try
        {
// Create a parser factory
            DocumentBuilderFactory factory = DocumentBuilderFactory.
                newInstance();

// Ask the parser factory to create a new parser
            DocumentBuilder parser = factory.newDocumentBuilder();

// This servlet just sends a plain text response
            response.setContentType("text/plain");

            PrintWriter out = response.getWriter();

// Create an input source around the request reader, ask the parser
// to parse the input source
            Document doc = parser.parse(new InputSource(request.getReader()));

// Get all the Name elements
            NodeList names = doc.getElementsByTagName("name");

            int numNames = names.getLength();

            for (int i=0; i < numNames; i++)
            {
                Element e = (Element) names.item(i);        

                String firstName = null;

// See if there is a first name
                NodeList firstNameList = e.getElementsByTagName("first");
                if (firstNameList.getLength() > 0)
                {
                    Element firstNameNode = (Element) firstNameList.item(0);

// Make the really bold assumption that <first> has a child and that
// it is text. You really should check first, though.
                    CharacterData nameText = (CharacterData)
                        firstNameNode.getFirstChild();

                    firstName = nameText.getData();
                }

                String lastName = null;

// See if there is a last name
                NodeList lastNameList = e.getElementsByTagName("last");
                if (lastNameList.getLength() > 0)
                {
                    Element lastNameNode = (Element) lastNameList.item(0);

// Make the really bold assumption that <last> has a child and that
// it is text. You really should check first, though.
                    CharacterData nameText = (CharacterData)
                        lastNameNode.getFirstChild();

                    lastName = nameText.getData();
                }

                if ((firstName != null) && (lastName != null))
                {
                    out.println(firstName+" "+lastName);
                }
            }
        }
        catch (ParserConfigurationException exc)
        {
            throw new ServletException(exc.toString());
        }
        catch (SAXException exc)
        {
            throw new ServletException(exc.toString());
        }
    }
}
