package usingjsp.scores;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;

import usingjsp.*;

public class RegisterScoreServlet extends HttpServlet
{
    public void service(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException
    {
        Connection conn = null;
        IConnectionPool pool = null;

        try
        {
// Require the user to enter a secret numeric code just to keep
// other people from entering fake scores
            String passCode = request.getParameter("passcode");

            if (!passCode.equals("12345")) // same code as my luggage!
            {
                throw new RuntimeException("Invalid passcode!");
            }

// Get a reference to the connection pool
            pool = ScoreSupport.getConnectionPool(getServletContext());
            
// Allocate a database connection
            conn = pool.getConnection();

// Create a new score object and populate its fields
            Score score = new Score();
            score.round = Integer.parseInt(
                request.getParameter("round"));
            score.player = request.getParameter("player");
            score.playerScore = Integer.parseInt(
                request.getParameter("score"));
            score.opponent = request.getParameter("opponent");
            score.opponentScore = Integer.parseInt(
                request.getParameter("opponentscore"));

// Insert the score into the database
            score.insert(conn);

// Assume that the client is using HTML
            String destPage = "/ScoreMenuHTML.jsp";

// If the client is using WML, send them to a different page
            if (ScoreSupport.isWML(request))
            {
                destPage = "/ScoreMenuWML.jsp";
            }

            getServletContext().getRequestDispatcher(destPage).forward(
                request, response);
        }
        catch (Exception exc)
        {
            String errorPage = "/ErrorHTML.jsp";

            if (ScoreSupport.isWML(request))
            {
                errorPage = "/ErrorWML.jsp";
            }

            request.setAttribute("exception", exc);

            exc.printStackTrace();

            getServletContext().getRequestDispatcher(errorPage).forward(
                request, response);
        }
        finally
        {
            if (conn != null)
            {
                try
                {
                    pool.releaseConnection(conn);
                } catch (Exception ignore) {}
            }
        }
    }
}
