package usingjsp;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import com.sun.image.codec.jpeg.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class EdgeDetectServlet extends HttpServlet
{
    public void doGet(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException
    {
// Make sure the browser asks for this file every time
        response.setHeader("Cache-Control", "no-cache");
        response.setHeader("Pragma", "no-cache");
        response.setHeader("Expires", "0");

        HttpSession session = request.getSession();

// Get the in-memory image
        BufferedImage buffImage =
            (BufferedImage) session.getAttribute("image");
        
// If there's no image, create a blank one
        if (buffImage == null)
        {
            buffImage = new BufferedImage(100, 100,
                BufferedImage.TYPE_INT_RGB);
        }

// Create an image to hold the edge-detected image
        BufferedImage outputImage =
            new BufferedImage(buffImage.getWidth(),
                buffImage.getHeight(), BufferedImage.TYPE_INT_RGB);

// Create a matrix for performing an edge-detection
		float matrix[] = { -5, 0, 0, 0, 0, 0, 0, 0, 5 };

		Kernel kernel = new Kernel(3, 3, matrix);

		ConvolveOp op = new ConvolveOp(kernel,
			ConvolveOp.EDGE_ZERO_FILL, null);

// Perform the edge-detect
		op.filter(buffImage, outputImage);

// Create an encoder to convert the image into JPEG format, using
// the servlet's output stream as the stream for writing the image
        JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(
            response.getOutputStream());

// Convert the image to JPeg
        encoder.encode(outputImage);

    }
}


