package usingjsp;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;

import java.awt.image.*;
import com.sun.image.codec.jpeg.*;

public class ReceiveImageUpload extends HttpServlet
{
    public void doPost(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException
    {
        HttpSession session = request.getSession();

        BufferedImage currImage =
            (BufferedImage) session.getAttribute("image");
        if (currImage != null)
        {
            currImage.flush();
        }

// Get the content type
        String contentType = request.getContentType();

// Set a default for the boundary string length
// Find out where the boundary string starts
        int boundaryIndex = contentType.indexOf("boundary=");

// Get the boundary string
        String boundary = contentType.substring(boundaryIndex+9);
        int boundaryStrLength = boundary.length();

// Get the input stream to read the uploaded file
        ServletInputStream servIn = request.getInputStream();

        DataInputStream in = new DataInputStream(servIn);

// Lop off the headers from the content (read until you get a blank line)
        String line;

        while ((line = in.readLine()) != null)
        {
            if (line.trim().length() == 0) break;
        }

// Create a decoder for JPEG data streams
        JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);

// Decode the JPEG
        BufferedImage image = decoder.decodeAsBufferedImage();

// Save the image so other servlets can access it
        session.setAttribute("image", image);

        
// Go to the image menu
        response.sendRedirect(
            "/jspbook/Chap27/ImageMenu.jsp?url="+
            URLEncoder.encode(
                "/servlet/usingjsp.ShowOriginalImageServlet"));
    }
}
