<%@ page language="java" import="java.text.*,java.util.*" %>
<%

// Get the default locale in case you can't determine the
// user's locale
    Locale locale = Locale.getDefault();

// Get the browser's preferred language
    String acceptLangString = request.getHeader("ACCEPT-LANGUAGE");

// If there is an ACCEPT-LANGUAGE header, parse it
    if (acceptLangString != null)
    {

// The accepted languages should be separater by commas, but also
// add space as a separator to eliminate whitespace
        StringTokenizer localeParser = new StringTokenizer(
            acceptLangString, " ,");

// See if there is a language in the list (you only need the first one)
        if (localeParser.hasMoreTokens())
        {
// Get the locale
            String localeStr = localeParser.nextToken();

// The locale should be in the format ll-CC where ll is the language
// and CC is the country, like en-US for English in the U.S. and
// de-DE for German in Germany. Allow the browser to use _ instead
// of -, too.
            StringTokenizer localeSplitter = new StringTokenizer(
                localeStr, "_-");

// Assume both values are blank
            String language = "";
            String country = "";

// See if there is a language specified
            if (localeSplitter.hasMoreTokens())
            {
                language = localeSplitter.nextToken();
            }

// See if there is a country specified (there won't always be one)
            if (localeSplitter.hasMoreTokens())
            {
                country = localeSplitter.nextToken();

            }

// Create a locale based on this language and country (if country is
// blank, you'll still get locale-based text, but currencies won't
// display correctly.
            locale = new Locale(language, country);
        }
    }
%>
<html>
<body>
Your locale language is <%=locale.getLanguage()%>.<p>
Your locale country is <%=locale.getCountry()%>.<p>
<%
// Get a formatter to display currency
    NumberFormat currencyFormatter =
        NumberFormat.getCurrencyInstance(locale);
    
// Get a formatter to display dates and times
    DateFormat dateFormatter =
        DateFormat.getDateTimeInstance(
            DateFormat.FULL, DateFormat.FULL, locale);
%>
A currency in your locale looks like this:
    <%= currencyFormatter.format(12.34) %><p>
A date in your locale looks like this:
    <%= dateFormatter.format(new Date()) %><p>
</body>
</html>
